DevExtreme v23.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.
Calendar

Calendar

When you add a Calendar to an application, you need to specify its value in one of the following formats:

  • Date objects

  • The number of milliseconds since 00:00:00 on January 1, 1970

  • Strings that match the following patterns:

    • 'yyyy-MM-dd'
    • 'yyyy-MM-ddTHH:mm:ss'
    • 'yyyy-MM-ddTHH:mm:ssZ'
    • 'yyyy-MM-ddTHH:mm:ssx'

This demo shows how to use additional properties to customize your Calendar. You can toggle the checkboxes on the right to change the Calendar in real time.

Disable Dates

Use the min and max properties to specify the range of available dates. In this demo, these properties limit the range to three days before and after the current date. Enable the "Set minimum date" and "Set maximum date" checkboxes to apply the properties.

If you need to disable specific dates, use the disabledDates property. Toggle the "Disable weekends" checkbox to see how this setting affects the component's behavior. You can specify either an array of predefined dates or a function that determines whether a date is available.

Specify First Day of Week and Display Week Numbers

To specify the first day of the week, assign its index (0 - for Sunday, 1 - for Monday, and so on) to the firstDayOfWeek property. You can also display a column with week numbers. For this, enable the showWeekNumbers property.

The start of the first week of the year depends on the locale. If you want to apply a specific rule, use the weekNumberRule property.

Handle Value Change

Set the onValueChanged property to handle the value change. In this demo, the DateBox and the Calendar both use this property to pass values between each other, and you can use one of these components to change the date.

Customize Cell Appearance

Use the cellTemplate property to customize cell appearance. In this demo, the following customizations are applied when you toggle the "Use custom cell template" checkbox:

  • All the weekends on the Calendar become blue.

  • All the holidays become red.

  • If a column with week numbers is shown, week numbers are italicized.

You can set your own function that changes the class of the span element that contains cell text.

Other Customizations

Set the disabled property to disable the Calendar.

To specify the initial calendar view (month, year, decade, or century), set the zoomLevel property.

Backend API
Copy to CodePen
Apply
Reset
$(() => { const msInDay = 1000 * 60 * 60 * 24; const zoomLevels = ['month', 'year', 'decade', 'century']; const weekDays = [ { id: 0, text: 'Sunday' }, { id: 1, text: 'Monday' }, { id: 2, text: 'Tuesday' }, { id: 3, text: 'Wednesday' }, { id: 4, text: 'Thursday' }, { id: 5, text: 'Friday' }, { id: 6, text: 'Saturday' }, ]; const weekNumberRules = ['auto', 'firstDay', 'firstFourDays', 'fullWeek']; const date = new Date().getTime(); const calendar = $('#calendar').dxCalendar({ value: new Date(), disabled: false, firstDayOfWeek: 0, showWeekNumbers: false, weekNumberRule: 'auto', zoomLevel: zoomLevels[0], onValueChanged(data) { selectedDate.option('value', data.value); }, onOptionChanged(data) { if (data.name === 'zoomLevel') { zoomLevel.option('value', data.value); } }, }).dxCalendar('instance'); $('#min-date').dxCheckBox({ text: 'Set minimum date', onValueChanged(data) { const minDate = new Date(date - msInDay * 3); calendar.option('min', data.value ? minDate : null); selectedDate.option('min', data.value ? minDate : null); }, }); $('#max-date').dxCheckBox({ text: 'Set maximum date', onValueChanged(data) { const maxDate = new Date(date + msInDay * 3); calendar.option('max', data.value ? maxDate : null); selectedDate.option('max', data.value ? maxDate : null); }, }); $('#disable-dates').dxCheckBox({ text: 'Disable weekends', onValueChanged(data) { if (data.value) { calendar.option('disabledDates', (d) => d.view === 'month' && isWeekend(d.date)); } else { calendar.option('disabledDates', null); } }, }); $('#week-numbers').dxCheckBox({ text: 'Show week numbers', onValueChanged(data) { calendar.option('showWeekNumbers', data.value); }, }); $('#disabled').dxCheckBox({ text: 'Disable the calendar', onValueChanged(data) { calendar.option('disabled', data.value); }, }); $('#custom-cell').dxCheckBox({ text: 'Use custom cell template', value: false, onValueChanged(data) { calendar.option('cellTemplate', data.value ? getCellTemplate : 'cell'); }, }); const zoomLevel = $('#zoom-level').dxSelectBox({ dataSource: zoomLevels, value: zoomLevels[0], inputAttr: { 'aria-label': 'Zoom Level' }, onValueChanged(data) { calendar.option('zoomLevel', data.value); }, }).dxSelectBox('instance'); const selectedDate = $('#selected-date').dxDateBox({ value: new Date(), inputAttr: { 'aria-label': 'Date' }, onValueChanged(data) { calendar.option('value', data.value); }, }).dxDateBox('instance'); $('#first-day-of-week').dxSelectBox({ dataSource: weekDays, value: 0, valueExpr: 'id', inputAttr: { 'aria-label': 'First Day of Week' }, displayExpr: 'text', onValueChanged(data) { calendar.option('firstDayOfWeek', data.value); }, }); $('#week-number-rule').dxSelectBox({ dataSource: weekNumberRules, value: weekNumberRules[0], inputAttr: { 'aria-label': 'Week Number Rule' }, onValueChanged(data) { calendar.option('weekNumberRule', data.value); }, }); const holidays = [[1, 0], [4, 6], [25, 11]]; function isWeekend(d) { const day = d.getDay(); return day === 0 || day === 6; } function getCellTemplate(data) { let cssClass = ''; if (data.view === 'month') { if (!data.date) { cssClass = 'week-number'; } else { if (isWeekend(data.date)) { cssClass = 'weekend'; } $.each(holidays, (_, item) => { if (data.date.getDate() === item[0] && data.date.getMonth() === item[1]) { cssClass = 'holiday'; return false; } return true; }); } } return `<span class='${cssClass}'>${data.text}</span>`; } });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.1.5/css/dx.light.css" /> <script src="https://cdn3.devexpress.com/jslib/23.1.5/js/dx.all.js"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div class="calendar-container"> <div id="calendar"></div> </div> <div class="options"> <div class="caption">Options</div> <div class="option"> <div id="min-date"></div> </div> <div class="option"> <div id="max-date"></div> </div> <div class="option"> <div id="disable-dates"></div> </div> <div class="option"> <div id="week-numbers"></div> </div> <div class="option"> <div id="custom-cell"></div> </div> <div class="option"> <div id="disabled"></div> </div> <div class="option"> <span>First day of week</span> <div id="first-day-of-week"></div> </div> <div class="option"> <span>Week number rule</span> <div id="week-number-rule"></div> </div> <div class="option"> <span>Zoom level</span> <div id="zoom-level"></div> </div> <div class="option"> <span>Selected date</span> <div id="selected-date"></div> </div> </div> </div> </body> </html>
.demo-container { display: flex; } .calendar-container { display: flex; flex-direction: column; flex-grow: 1; align-items: center; justify-content: center; } .dx-calendar-cell:not(.dx-calendar-other-month) .weekend, .dx-calendar-cell:not(.dx-calendar-other-month) .holiday { text-shadow: none; font-weight: bold; } .dx-calendar-cell:not(.dx-calendar-other-month) .weekend { color: #3030ff; } .dx-state-disabled.dx-calendar .dx-calendar-cell:not(.dx-calendar-other-month) .weekend { color: #8080ff; } .dx-calendar-cell:not(.dx-calendar-other-month) .holiday { color: #ff3030; } .dx-state-disabled.dx-calendar .dx-calendar-cell:not(.dx-calendar-other-month) .holiday { color: #ff8080; } .dx-calendar-week-number-cell .week-number { font-style: italic; } .caption { font-weight: 500; font-size: 18px; } .options { padding: 20px; background-color: rgba(191, 191, 191, 0.15); } .option { margin-top: 10px; }

<div id="calendar-demo">
<div class="widget-container">
<dx-calendar #calendar
id="calendar-container"
[min]="minDateValue"
[max]="maxDateValue"
[disabledDates]="disabledDates"
[firstDayOfWeek]="firstDay"
[disabled]="false"
[(value)]="currentValue"
[zoomLevel]="zoomLevels[0]"
[cellTemplate]="cellTemplate">
<span *dxTemplate="let cell of 'custom'" [ngClass]="getCellCssClass(cell.date)">
{{cell.text}}
</span>
</dx-calendar>
</div>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<dx-check-box
text="Specified min value"
[value]="false"
(onValueChanged)="setMinDate($event)">
</dx-check-box>
</div>
<div class="option">
<dx-check-box
text="Specified max value"
[value]="false"
(onValueChanged)="setMaxDate($event)">
</dx-check-box>
</div>
<div class="option">
<dx-check-box
text="Disable weekend"
[value]="false"
(onValueChanged)="disableWeekend($event)">
</dx-check-box>
</div>
<div class="option">
<dx-check-box
text="Monday as the first day of a week"
[value]="false"
(onValueChanged)="setFirstDay($event)">
</dx-check-box>
</div>
<div class="option">
<dx-check-box
text="Use the Custom Cell Template"
[value]="false"
(onValueChanged)="useCellTemplate($event)">
</dx-check-box>
</div>
<div class="option">
<dx-check-box #calendarDisabled
[(value)]="calendar.disabled"
text="Disabled">
</dx-check-box>
</div>
<div class="option">
<span>Zoom level</span>
<dx-select-box
id="zoom-level"
[dataSource]="zoomLevels"
[(value)]="calendar.zoomLevel">
</dx-select-box>
</div>
<div class="option">
<span>Selected date</span>
<dx-date-box
id="selected-date"
width="100%"
[(value)]="currentValue">
</dx-date-box>
</div>
</div>
</div>
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { DxSelectBoxModule,
DxCheckBoxModule,
DxDateBoxModule,
DxCalendarModule,
DxTemplateModule } from 'devextreme-angular';
if(!/localhost/.test(document.location.host)) {
enableProdMode();
}
@Component({
selector: 'demo-app',
templateUrl: 'app/app.component.html',
styleUrls: ['app/app.component.css']
})
export class AppComponent {
now: Date = new Date();
currentValue: Date = new Date();
firstDay: number = 0;
minDateValue: Date = undefined;
maxDateValue: Date = undefined;
disabledDates: Function = null;
zoomLevels: string[] = [
"month", "year", "decade", "century"
];
cellTemplate = "cell";
holydays: any = [[1,0], [4,6], [25,11]];
isWeekend(date) {
var day = date.getDay();
return day === 0 || day === 6;
}
setMinDate(e) {
if(e.value) {
this.minDateValue = new Date(this.now.getTime() - 1000*60*60*24*3);
} else {
this.minDateValue = undefined;
}
}
setMaxDate(e) {
if(e.value) {
this.maxDateValue = new Date(this.now.getTime() + 1000*60*60*24*3);
} else {
this.maxDateValue = undefined;
}
}
disableWeekend(e) {
if(e.value) {
var that = this;
that.disabledDates = function(data) {
return data.view === "month" && that.isWeekend(data.date);
};
} else {
this.disabledDates = undefined;
}
}
setFirstDay(e) {
if(e.value) {
this.firstDay = 1;
} else {
this.firstDay = 0;
}
}
useCellTemplate(e) {
if(e.value) {
this.cellTemplate = "custom";
} else {
this.cellTemplate = "cell";
}
}
getCellCssClass(date) {
var cssClass = "";
if(this.isWeekend(date))
cssClass = "weekend";
this.holydays.forEach(function(item) {
if(date.getDate() === item[0] && date.getMonth() === item[1]) {
cssClass = "holyday";
return false;
}
});
return cssClass;
}
}
@NgModule({
imports: [
BrowserModule,
DxSelectBoxModule,
DxCalendarModule,
DxCheckBoxModule,
DxDateBoxModule,
DxTemplateModule
],
declarations: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep .widget-container {
margin-right: 320px;
}
::ng-deep #calendar-container {
margin: auto;
}
::ng-deep .dx-calendar-cell:not(.dx-calendar-other-month) .weekend,
::ng-deep .dx-calendar-cell:not(.dx-calendar-other-month) .holyday {
text-shadow: none;
font-weight: bold;
}
::ng-deep .dx-calendar-cell:not(.dx-calendar-other-month) .weekend {
color: #3030FF;
}
::ng-deep .dx-state-disabled.dx-calendar .dx-calendar-cell:not(.dx-calendar-other-month) .weekend {
color: #8080FF;
}
::ng-deep .dx-calendar-cell:not(.dx-calendar-other-month) .holyday {
color: #FF3030;
}
::ng-deep .dx-state-disabled.dx-calendar .dx-calendar-cell:not(.dx-calendar-other-month) .holyday {
color: #FF8080;
}
::ng-deep .options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
position: absolute;
right: 0;
top: 0;
bottom: 0;
width: 260px;
}
::ng-deep .caption {
font-weight: 500;
font-size: 18px;
}
::ng-deep .option {
margin-top: 10px;
}
// In real applications, you should not transpile code in the browser. You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
System.config({
transpiler: 'ts',
typescriptOptions: {
module: "system",
emitDecoratorMetadata: true,
experimentalDecorators: true
},
meta: {
'typescript': {
"exports": "ts"
},
'devextreme/localization.js': {
"esModule": true
}
},
paths: {
'npm:': 'https://unpkg.com/'
},
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@3.5.3/lib/typescript.js',
'@angular': 'npm:@angular',
'tslib': 'npm:tslib@2.0.3/tslib.js',
'rxjs': 'npm:rxjs@6.3.3',
'rrule': 'npm:rrule@2.6.6/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.25.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@20.2.4',
'jszip': 'npm:jszip@3.5.0/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@0.9.7/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.0.5',
'devexpress-gantt': 'npm:devexpress-gantt@2.0.8',
'devextreme-angular': 'npm:devextreme-angular@20.2.4',
'preact': 'npm:preact@10.5.7/dist/preact.js',
'preact/hooks': 'npm:preact@10.5.7/hooks/dist/hooks.js'
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts'
},
'devextreme': {
defaultExtension: 'js'
},
'devextreme/events/utils': {
main: 'index'
},
'devextreme/events': {
main: 'index'
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js'
}
},
packageConfigPaths: [
"npm:@angular/*/package.json",
"npm:@angular/common/*/package.json",
"npm:rxjs/package.json",
"npm:rxjs/operators/package.json",
"npm:devextreme-angular/*/package.json",
"npm:devextreme-angular/ui/*/package.json",
"npm:devextreme-angular/package.json",
"npm:devexpress-diagram/package.json",
"npm:devexpress-gantt/package.json",
]
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.4/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.4/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/zone.js@0.10.2/dist/zone.js"></script>
<script src="https://unpkg.com/reflect-metadata@0.1.3/Reflect.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import('app').catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

Your search did not match any results.
Calendar

Calendar

When you add a Calendar to an application, you need to specify its value in one of the following formats:

  • Date objects

  • The number of milliseconds since 00:00:00 on January 1, 1970

  • Strings that match the following patterns:

    • 'yyyy-MM-dd'
    • 'yyyy-MM-ddTHH:mm:ss'
    • 'yyyy-MM-ddTHH:mm:ssZ'
    • 'yyyy-MM-ddTHH:mm:ssx'

This demo shows how to use additional properties to customize your Calendar. You can toggle the checkboxes on the right to change the Calendar in real time.

Disable Dates

Use the min and max properties to specify the range of available dates. In this demo, these properties limit the range to three days before and after the current date. Enable the "Set minimum date" and "Set maximum date" checkboxes to apply the properties.

If you need to disable specific dates, use the disabledDates property. Toggle the "Disable weekends" checkbox to see how this setting affects the component's behavior. You can specify either an array of predefined dates or a function that determines whether a date is available.

Specify First Day of Week and Display Week Numbers

To specify the first day of the week, assign its index (0 - for Sunday, 1 - for Monday, and so on) to the firstDayOfWeek property. You can also display a column with week numbers. For this, enable the showWeekNumbers property.

The start of the first week of the year depends on the locale. If you want to apply a specific rule, use the weekNumberRule property.

Handle Value Change

Set the onValueChanged property to handle the value change. In this demo, the DateBox and the Calendar both use this property to pass values between each other, and you can use one of these components to change the date.

Customize Cell Appearance

Use the cellTemplate property to customize cell appearance. In this demo, the following customizations are applied when you toggle the "Use custom cell template" checkbox:

  • All the weekends on the Calendar become blue.

  • All the holidays become red.

  • If a column with week numbers is shown, week numbers are italicized.

You can set your own function that changes the class of the span element that contains cell text.

Other Customizations

Set the disabled property to disable the Calendar.

To specify the initial calendar view (month, year, decade, or century), set the zoomLevel property.

Backend API
Copy to CodeSandBox
Apply
Reset
import React from 'react'; import CheckBox from 'devextreme-react/check-box'; import SelectBox from 'devextreme-react/select-box'; import DateBox from 'devextreme-react/date-box'; import Calendar from 'devextreme-react/calendar'; import CustomCell, { isWeekend } from './CustomCell.js'; const zoomLevels = ['month', 'year', 'decade', 'century']; const weekNumberRules = ['auto', 'firstDay', 'firstFourDays', 'fullWeek']; const weekDays = [ { id: 0, text: 'Sunday' }, { id: 1, text: 'Monday' }, { id: 2, text: 'Tuesday' }, { id: 3, text: 'Wednesday' }, { id: 4, text: 'Thursday' }, { id: 5, text: 'Friday' }, { id: 6, text: 'Saturday' }, ]; export default function App() { const [minDateValue, setMinDateValue] = React.useState(null); const [maxDateValue, setMaxDateValue] = React.useState(null); const [weekendDisabled, setWeekendDisabled] = React.useState(null); const [firstDay, setFirstDay] = React.useState(0); const [weekNumberRule, setWeekNumberRule] = React.useState('auto'); const [showWeekNumbers, setShowWeekNumbers] = React.useState(false); const [currentValue, setCurrentValue] = React.useState(new Date()); const [useCellTemplate, setUseCellTemplate] = React.useState(null); const [disabled, setDisabled] = React.useState(false); const [zoomLevel, setZoomLevel] = React.useState('month'); const onCurrentValueChange = React.useCallback(({ value }) => { setCurrentValue(value); }, [setCurrentValue]); const onDisabledChange = React.useCallback(({ value }) => { setDisabled(value); }, [setDisabled]); const onZoomLevelChange = React.useCallback(({ value }) => { setZoomLevel(value); }, [setZoomLevel]); const onMinDateChange = React.useCallback(({ value }) => { setMinDateValue( value ? new Date(new Date().getTime() - 1000 * 60 * 60 * 24 * 3) : null, ); }, [setMinDateValue]); const onMaxDateChange = React.useCallback(({ value }) => { setMaxDateValue( value ? new Date(new Date().getTime() + 1000 * 60 * 60 * 24 * 3) : null, ); }, [setMaxDateValue]); const onDisableWeekendChange = React.useCallback(({ value }) => { setWeekendDisabled(value); }, [setWeekendDisabled]); const onFirstDayChange = React.useCallback(({ value }) => { setFirstDay(value); }, [setFirstDay]); const onWeekNumberRuleChange = React.useCallback(({ value }) => { setWeekNumberRule(value); }, [setWeekNumberRule]); const onShowWeekNumbersChange = React.useCallback(({ value }) => { setShowWeekNumbers(value); }, [setShowWeekNumbers]); const onUseCellTemplateChange = React.useCallback(({ value }) => { setUseCellTemplate(!!value); }, [setUseCellTemplate]); const isDateDisabled = React.useCallback(({ view, date }) => view === 'month' && isWeekend(date), []); const onOptionChange = React.useCallback((e) => { if (e.name === 'zoomLevel') { onZoomLevelChange(e); } }, [onZoomLevelChange]); return ( <div id="container"> <div className="calendar-container"> <Calendar value={currentValue} onValueChanged={onCurrentValueChange} onOptionChanged={onOptionChange} min={minDateValue} max={maxDateValue} disabledDates={weekendDisabled ? isDateDisabled : null} firstDayOfWeek={firstDay} weekNumberRule={weekNumberRule} showWeekNumbers={showWeekNumbers} disabled={disabled} zoomLevel={zoomLevel} cellRender={useCellTemplate ? CustomCell : null} /> </div> <div className="options"> <div className="caption">Options</div> <div className="option"> <CheckBox defaultValue={false} text="Set minimum date" onValueChanged={onMinDateChange} /> </div> <div className="option"> <CheckBox defaultValue={false} text="Set maximum date" onValueChanged={onMaxDateChange} /> </div> <div className="option"> <CheckBox defaultValue={false} text="Disable weekends" onValueChanged={onDisableWeekendChange} /> </div> <div className="option"> <CheckBox defaultValue={false} text="Show week numbers" onValueChanged={onShowWeekNumbersChange} /> </div> <div className="option"> <CheckBox defaultValue={false} text="Use custom cell template" onValueChanged={onUseCellTemplateChange} /> </div> <div className="option"> <CheckBox value={disabled} text="Disable the calendar" onValueChanged={onDisabledChange} /> </div> <div className="option"> <span>First day of week</span> <SelectBox dataSource={weekDays} displayExpr="text" valueExpr="id" value={firstDay} onValueChanged={onFirstDayChange} /> </div> <div className="option"> <span>Week number rule</span> <SelectBox dataSource={weekNumberRules} value={weekNumberRule} onValueChanged={onWeekNumberRuleChange} /> </div> <div className="option"> <span>Zoom level</span> <SelectBox dataSource={zoomLevels} value={zoomLevel} onValueChanged={onZoomLevelChange} /> </div> <div className="option"> <span>Selected date</span> <DateBox id="selected-date" value={currentValue} onValueChanged={onCurrentValueChange} min={minDateValue} max={maxDateValue} /> </div> </div> </div> ); }
import React from 'react'; import ReactDOM from 'react-dom'; import App from './App.js'; ReactDOM.render( <App />, document.getElementById('app'), );
<!DOCTYPE html> <html> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.2.6/css/dx.light.css" /> <link rel="stylesheet" type="text/css" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.6.3/css/font-awesome.min.css" /> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script> <script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script> <script type="text/javascript" src="config.js"></script> <script type="text/javascript"> System.import("./index.js"); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="app"></div> </div> </body> </html>
#container { display: flex; } .calendar-container { display: flex; flex-direction: column; flex-grow: 1; align-items: center; justify-content: center; } .dx-calendar-cell:not(.dx-calendar-other-month) .weekend, .dx-calendar-cell:not(.dx-calendar-other-month) .holiday { text-shadow: none; font-weight: bold; } .dx-calendar-cell:not(.dx-calendar-other-month) .weekend { color: #3030ff; } .dx-state-disabled.dx-calendar .dx-calendar-cell:not(.dx-calendar-other-month) .weekend { color: #8080ff; } .dx-calendar-cell:not(.dx-calendar-other-month) .holiday { color: #ff3030; } .dx-state-disabled.dx-calendar .dx-calendar-cell:not(.dx-calendar-other-month) .holiday { color: #ff8080; } .dx-calendar-week-number-cell .week-number { font-style: italic; } .caption { font-weight: 500; font-size: 18px; } .options { padding: 20px; background-color: rgba(191, 191, 191, 0.15); } .option { margin-top: 10px; }
import React from 'react'; export function isWeekend(date) { const day = date.getDay(); return day === 0 || day === 6; } function getCellCssClass({ date, view }) { let cssClass = ''; const holidays = [[1, 0], [4, 6], [25, 11]]; if (view === 'month') { if (!date) { cssClass = 'week-number'; } else { if (isWeekend(date)) { cssClass = 'weekend'; } holidays.forEach((item) => { if (date.getDate() === item[0] && date.getMonth() === item[1]) { cssClass = 'holiday'; } }); } } return cssClass; } function CustomCell(cell) { const { text, } = cell; const className = getCellCssClass(cell); return ( <span className={className}> { text } </span> ); } export default CustomCell;
window.config = { transpiler: 'plugin-babel', meta: { 'devextreme/localization.js': { 'esModule': true, }, }, paths: { 'npm:': 'https://unpkg.com/', }, defaultExtension: 'js', map: { 'react': 'npm:react@17.0.2/umd/react.development.js', 'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js', 'prop-types': 'npm:prop-types@15.8.1/prop-types.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign@1.1.0', 'devextreme': 'npm:devextreme@22.2.6/cjs', 'devextreme-react': 'npm:devextreme-react@22.2.6', 'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js', 'devextreme-quill': 'npm:devextreme-quill@1.5.20/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.1.72/dist/dx-diagram.js', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.43/dist/dx-gantt.js', '@devextreme/runtime': 'npm:@devextreme/runtime@3.0.11', 'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', // SystemJS plugins 'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js', 'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.4/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.4/parser-html.js', }, packages: { 'devextreme': { defaultExtension: 'js', }, 'devextreme-react': { main: 'index.js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', 'npm:@devextreme/runtime@3.0.11/inferno/package.json', ], babelOptions: { sourceMaps: false, stage0: true, react: true, }, }; System.config(window.config);

DevExtreme v25.2 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

Vue Calendar - Overview

This demo shows how to use additional properties to customize your Calendar. You can toggle the checkboxes on the right to change the Calendar in real time.

DevExtreme Accessibility Compliance
DevExtreme component libraries meet a variety of WCAG and Section 508 compliance standards. To assess this demo's accessibility level, click the Run AXE® Validation button to launch the AXE® web accessibility evaluation tool.
All trademarks or registered trademarks are property of their respective owners. AXE® Terms of Use
The overall accessibility level of your application depends on the Calendar features used.
Backend API
<template> <div id="calendar-demo"> <div class="calendar-container"> <DxCalendar v-model:value="currentValue" v-model:zoom-level="zoomLevel" :first-day-of-week="firstDay" :show-week-numbers="showWeekNumbers" :week-number-rule="weekNumberRule" :disabled="disabled" :cell-template="cellTemplate" > <template #custom="{ data: cell }"> <span :class="getCellCssClass(cell)"> {{ cell.text }} </span> </template> </DxCalendar> </div> <div class="options"> <div class="caption">Options</div> <div class="option"> <span>Zoom level</span> <DxSelectBox v-model:value="zoomLevel" :input-attr="{ 'aria-label': 'Zoom Level' }" :data-source="zoomLevels" /> </div> <div class="option"> <span>Selected date</span> <DxDateBox v-model:value="currentValue" :input-attr="{ 'aria-label': 'Date' }" /> </div> <div class="option"> <DxCheckBox :value="false" text="Use custom cell template" @value-changed="useCellTemplate" /> </div> <div class="option"> <DxCheckBox v-model:value="disabled" text="Disable the calendar" /> </div> <div class="caption option"> <span>Week numeration</span> </div> <div class="option"> <DxCheckBox v-model:value="showWeekNumbers" text="Show week numbers" /> </div> <div class="option"> <span>First day of week</span> <DxSelectBox v-model:value="firstDay" :data-source="weekDays" :input-attr="{ 'aria-label': 'First Day of Week' }" value-expr="id" display-expr="text" /> </div> <div class="option"> <span>Week number rule</span> <DxSelectBox v-model:value="weekNumberRule" :input-attr="{ 'aria-label': 'Week Number Rule' }" :data-source="weekNumberRules" /> </div> </div> </div> </template> <script setup lang="ts"> import { ref } from 'vue'; import DxCheckBox, { type DxCheckBoxTypes } from 'devextreme-vue/check-box'; import DxSelectBox from 'devextreme-vue/select-box'; import DxDateBox from 'devextreme-vue/date-box'; import DxCalendar, { type DxCalendarTypes } from 'devextreme-vue/calendar'; const zoomLevels: DxCalendarTypes.CalendarZoomLevel[] = ['month', 'year', 'decade', 'century']; const zoomLevel = ref<DxCalendarTypes.CalendarZoomLevel>('month'); const currentValue = ref(new Date()); const cellTemplate = ref('cell'); const disabled = ref(false); const showWeekNumbers = ref(false); const firstDay = ref<DxCalendarTypes.FirstDayOfWeek>(0); const weekNumberRule = ref<DxCalendarTypes.WeekNumberRule>('auto'); const weekDays = [ { id: 0, text: 'Sunday' }, { id: 1, text: 'Monday' }, { id: 2, text: 'Tuesday' }, { id: 3, text: 'Wednesday' }, { id: 4, text: 'Thursday' }, { id: 5, text: 'Friday' }, { id: 6, text: 'Saturday' }, ]; const weekNumberRules = ['auto', 'firstDay', 'firstFourDays', 'fullWeek']; function isWeekend(date: Date) { const day = date.getDay(); return day === 0 || day === 6; } const holidays = [[1, 0], [4, 6], [25, 11]]; function isHoliday(date: Date) { return holidays.some((item) => date.getDate() === item[0] && date.getMonth() === item[1]); } function useCellTemplate({ value }: DxCheckBoxTypes.ValueChangedEvent) { cellTemplate.value = value ? 'custom' : 'cell'; } function getCellCssClass({ date, view }: { date: Date, view: string }) { let cssClass = ''; if (view === 'month') { if (!date) { cssClass = 'week-number'; } else { if (isWeekend(date)) { cssClass = 'weekend'; } if (isHoliday(date)) { cssClass = 'holiday'; } } } return cssClass; } </script> <style scoped> #calendar-demo { display: flex; } .calendar-container { display: flex; flex-direction: column; flex-grow: 1; align-items: center; justify-content: center; } .dx-calendar-cell:not(.dx-calendar-other-month) .weekend, .dx-calendar-cell:not(.dx-calendar-other-month) .holiday { text-shadow: none; font-weight: bold; } .dx-calendar-cell:not(.dx-calendar-other-month) .weekend { color: #3030ff; } .dx-state-disabled.dx-calendar .dx-calendar-cell:not(.dx-calendar-other-month) .weekend { color: #8080ff; } .dx-calendar-cell:not(.dx-calendar-other-month) .holiday { color: #ff3030; } .dx-state-disabled.dx-calendar .dx-calendar-cell:not(.dx-calendar-other-month) .holiday { color: #ff8080; } .dx-calendar-week-number-cell .week-number { font-style: italic; } .caption { font-weight: 500; font-size: 18px; } .options { padding: 20px; background-color: rgba(191, 191, 191, 0.15); } .option { margin-top: 10px; } </style>
window.exports = window.exports || {}; window.config = { transpiler: 'plugin-babel', meta: { '*.vue': { loader: 'vue-loader', }, '*.ts': { loader: 'demo-ts-loader', }, '*.svg': { loader: 'svg-loader', }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, 'openai': { 'esModule': true, }, }, paths: { 'project:': '../../../../', 'npm:': 'https://cdn.jsdelivr.net/npm/', 'bundles:': '../../../../bundles/', 'externals:': '../../../../bundles/externals/', }, map: { 'vue': 'npm:vue@3.4.27/dist/vue.esm-browser.js', '@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js', 'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js', 'demo-ts-loader': 'project:utils/demo-ts-loader.js', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', 'svg-loader': 'project:utils/svg-loader.js', 'mitt': 'npm:mitt/dist/mitt.umd.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign', 'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs', 'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs', 'devextreme-quill': 'npm:devextreme-quill@1.7.7/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.24/dist/dx-diagram.js', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.64/dist/dx-gantt.js', 'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', '@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js', 'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js', 'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.8/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js', }, packages: { 'devextreme-vue': { main: 'index.js', }, 'devextreme-vue/common': { main: 'index.js', }, 'devextreme': { defaultExtension: 'js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/common/core/events/utils': { main: 'index', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', ], babelOptions: { sourceMaps: false, stage0: true, }, }; window.process = { env: { NODE_ENV: 'production', }, }; System.config(window.config); // eslint-disable-next-line const useTgzInCSB = ['openai'];
import { createApp } from 'vue'; import App from './App.vue'; createApp(App).mount('#app');
<!DOCTYPE html> <html lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.3/css/dx.light.css" /> <link rel="stylesheet" type="text/css" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.6.3/css/font-awesome.min.css" /> <script type="module"> import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js"; window.vueCompilerSFC = vueCompilerSFC; </script> <script src="https://cdn.jsdelivr.net/npm/typescript@5.9.3/lib/typescript.js"></script> <script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script> <script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script> <script type="text/javascript" src="config.js"></script> <script type="text/javascript"> System.import("./index.ts"); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="app"> </div> </div> </body> </html>

When you add a Calendar to an application, you need to specify its value in one of the following formats:

  • Date
    Specifies the date directly.

  • Number
    Specifies the date with a timestamp (total milliseconds since 1970/01/01).

  • String
    Specifies the date with a string value. The UI component supports the following formats of a date string:

    • "yyyy-MM-dd" (for example, "2017-03-06")
    • "yyyy-MM-ddTHH:mm:ss" (for example, "2017-03-27T16:54:48")
    • "yyyy-MM-ddTHH:mm:ssZ" (for example, "2017-03-27T13:55:41Z")
    • "yyyy-MM-ddTHH:mm:ssx" (for example, "2017-03-27T16:54:10+03")
  • Array of the formats mentioned before
    Available only for 'multiple' and 'range' selection modes. The array includes all selected dates.

Specify First Day of Week and Display Week Numbers

To specify the first day of the week, assign its index (0 - for Sunday, 1 - for Monday, and so on) to the firstDayOfWeek property. You can also display a column with week numbers. For this, enable the showWeekNumbers property.

The start of the first week of the year depends on the locale. If you want to apply a specific rule, use the weekNumberRule property.

Handle Value Change

Set the onValueChanged property to handle the value change. In this demo, the DateBox and the Calendar both use this property to pass values between each other, and you can use one of these components to change the date.

Customize Cell Appearance

Use the cellTemplate property to customize cell appearance. In this demo, the following customizations are applied when you toggle the "Use custom cell template" checkbox:

  • All the weekends on the Calendar become blue.

  • All the holidays become red.

  • If a column with week numbers is shown, week numbers are italicized.

You can set your own function that changes the class of the span element that contains cell text.

Other Customizations

Set the disabled property to disable the Calendar.

To specify the initial calendar view (month, year, decade, or century), set the zoomLevel property.